---
# Starts servers and joins nodes to controller

- name: Start controller servers
  systemd:
    state: started
    name: k3s
  when: inventory_hostname in groups ['controllers']
  become: yes

- name: Get Controller Node-Token
  fetch:
    src: /var/lib/rancher/k3s/server/node-token
    dest: ./node-token
    flat: yes
  register: controllerToken
  when: inventory_hostname in groups ['controllers']
  become: yes
  retries: 50
  delay: 6
  register: nodeTokenStatus
  until: nodeTokenStatus is not failed 

- name: Change permisson on k3s.yaml on controller
  file:
    path: /etc/rancher/k3s/k3s.yaml
    owner: root
    group: wheel
    mode: '0640'
  become: yes
  register: k3sPermissions
  retries: 3
  delay: 2
  until: k3sPermissions is not failed
  when: inventory_hostname in groups ['controllers']

- name: Set Controller Node-Token on workers
  copy:
    dest: "~/k3s/node-token"
    src: ./node-token
    mode: 0755
  register: workerToken

- name: Writing k3s Agent Environment File
  vars: 
    controller_node_token: "{{ lookup('file', './node-token') }}"
  template:
    src: k3s-agent.template
    dest: /etc/systemd/system/k3s-agent.service.env   
    owner: root
    group: root
    mode: 0600
  become: yes
  
- name: Start workers 
  systemd: 
    state: started
    name: k3s-agent
  when: inventory_hostname in groups ['workers']
  become: yes
